Asterisk.org: Developer Documentation (28 Oct 2009)

Wed Oct 28 15:49:05 2009

## Asterisk developer's documentation

# md5.h File Reference

MD5 digest functions. More...

`#include <inttypes.h>`

Include dependency graph for md5.h:

This graph shows which files directly or indirectly include this file:

Go to the source code of this file.

## Data Structures

struct | MD5Context

## Functions

void | MD5Final (unsigned char digest[16], struct MD5Context *context)
void | MD5Init (struct MD5Context *context)
void | MD5Transform (uint32_t buf[4], uint32_t const in[16])
void | MD5Update (struct MD5Context *context, unsigned char const *buf, unsigned len)

## Detailed Description

MD5 digest functions.

Definition in file md5.h.

## Function Documentation

void MD5Final | ( | unsigned char | digest[16],
|  | struct MD5Context * | context |
| ) |  |  |

Definition at line 123 of file md5.c.

References MD5Context::bits, MD5Context::buf, byteReverse(), MD5Context::in, and MD5Transform().

Referenced by ast_md5_hash(), authenticate(), authenticate_verify(), decrypt_frame(), festival_exec(), prov_ver_calc(), register_verify(), try_firmware(), try_load_key(), and verify_key().

    00124 {
    00125    unsigned count;
    00126    unsigned char *p;
    00127
    00128    /* Compute number of bytes mod 64 */
    00129    count = (ctx->bits[0] >> 3) & 0x3F;
    00130
    00131    /* Set the first char of padding to 0x80.  This is safe since there is
    00132       always at least one byte free */
    00133    p = ctx->in + count;
    00134    *p++ = 0x80;
    00135
    00136    /* Bytes of padding needed to make 64 bytes */
    00137    count = 64 - 1 - count;
    00138
    00139    /* Pad out to 56 mod 64 */
    00140    if (count < 8) {
    00141       /* Two lots of padding:  Pad the first block to 64 bytes */
    00142       memset(p, 0, count);
    00143       byteReverse(ctx->in, 16);
    00144       MD5Transform(ctx->buf, (uint32_t *) ctx->in);
    00145
    00146       /* Now fill the next block with 56 bytes */
    00147       memset(ctx->in, 0, 56);
    00148    } else {
    00149       /* Pad block to 56 bytes */
    00150       memset(p, 0, count - 8);
    00151    }
    00152    byteReverse(ctx->in, 14);
    00153
    00154    /* Append length in bits and transform */
    00155    ((uint32_t *) ctx->in)[14] = ctx->bits[0];
    00156    ((uint32_t *) ctx->in)[15] = ctx->bits[1];
    00157
    00158    MD5Transform(ctx->buf, (uint32_t *) ctx->in);
    00159    byteReverse((unsigned char *) ctx->buf, 4);
    00160    memcpy(digest, ctx->buf, 16);
    00161    memset(ctx, 0, sizeof(ctx));  /* In case it's sensitive */
    00162 }

void MD5Init | ( | struct MD5Context * | context | ) |

Definition at line 60 of file md5.c.

References MD5Context::bits, and MD5Context::buf.

Referenced by ast_md5_hash(), authenticate(), authenticate_verify(), decrypt_frame(), festival_exec(), prov_ver_calc(), register_verify(), try_firmware(), try_load_key(), and verify_key().

    00061 {
    00062    ctx->buf[0] = 0x67452301;
    00063    ctx->buf[1] = 0xefcdab89;
    00064    ctx->buf[2] = 0x98badcfe;
    00065    ctx->buf[3] = 0x10325476;
    00066
    00067    ctx->bits[0] = 0;
    00068    ctx->bits[1] = 0;
    00069 }

void MD5Transform | ( | uint32_t | buf[4],
|  | uint32_t const | in[16] |
| ) |  |  |

Definition at line 183 of file md5.c.

References F1, F2, F3, F4, and MD5STEP.

Referenced by MD5Final(), and MD5Update().

    00184 {
    00185    register uint32_t a, b, c, d;
    00186
    00187    a = buf[0];
    00188    b = buf[1];
    00189    c = buf[2];
    00190    d = buf[3];
    00191
    00192    MD5STEP(F1, a, b, c, d, in[0] + 0xd76aa478, 7);
    00193    MD5STEP(F1, d, a, b, c, in[1] + 0xe8c7b756, 12);
    00194    MD5STEP(F1, c, d, a, b, in[2] + 0x242070db, 17);
    00195    MD5STEP(F1, b, c, d, a, in[3] + 0xc1bdceee, 22);
    00196    MD5STEP(F1, a, b, c, d, in[4] + 0xf57c0faf, 7);
    00197    MD5STEP(F1, d, a, b, c, in[5] + 0x4787c62a, 12);
    00198    MD5STEP(F1, c, d, a, b, in[6] + 0xa8304613, 17);
    00199    MD5STEP(F1, b, c, d, a, in[7] + 0xfd469501, 22);
    00200    MD5STEP(F1, a, b, c, d, in[8] + 0x698098d8, 7);
    00201    MD5STEP(F1, d, a, b, c, in[9] + 0x8b44f7af, 12);
    00202    MD5STEP(F1, c, d, a, b, in[10] + 0xffff5bb1, 17);
    00203    MD5STEP(F1, b, c, d, a, in[11] + 0x895cd7be, 22);
    00204    MD5STEP(F1, a, b, c, d, in[12] + 0x6b901122, 7);
    00205    MD5STEP(F1, d, a, b, c, in[13] + 0xfd987193, 12);
    00206    MD5STEP(F1, c, d, a, b, in[14] + 0xa679438e, 17);
    00207    MD5STEP(F1, b, c, d, a, in[15] + 0x49b40821, 22);
    00208
    00209    MD5STEP(F2, a, b, c, d, in[1] + 0xf61e2562, 5);
    00210    MD5STEP(F2, d, a, b, c, in[6] + 0xc040b340, 9);
    00211    MD5STEP(F2, c, d, a, b, in[11] + 0x265e5a51, 14);
    00212    MD5STEP(F2, b, c, d, a, in[0] + 0xe9b6c7aa, 20);
    00213    MD5STEP(F2, a, b, c, d, in[5] + 0xd62f105d, 5);
    00214    MD5STEP(F2, d, a, b, c, in[10] + 0x02441453, 9);
    00215    MD5STEP(F2, c, d, a, b, in[15] + 0xd8a1e681, 14);
    00216    MD5STEP(F2, b, c, d, a, in[4] + 0xe7d3fbc8, 20);
    00217    MD5STEP(F2, a, b, c, d, in[9] + 0x21e1cde6, 5);
    00218    MD5STEP(F2, d, a, b, c, in[14] + 0xc33707d6, 9);
    00219    MD5STEP(F2, c, d, a, b, in[3] + 0xf4d50d87, 14);
    00220    MD5STEP(F2, b, c, d, a, in[8] + 0x455a14ed, 20);
    00221    MD5STEP(F2, a, b, c, d, in[13] + 0xa9e3e905, 5);
    00222    MD5STEP(F2, d, a, b, c, in[2] + 0xfcefa3f8, 9);
    00223    MD5STEP(F2, c, d, a, b, in[7] + 0x676f02d9, 14);
    00224    MD5STEP(F2, b, c, d, a, in[12] + 0x8d2a4c8a, 20);
    00225
    00226    MD5STEP(F3, a, b, c, d, in[5] + 0xfffa3942, 4);
    00227    MD5STEP(F3, d, a, b, c, in[8] + 0x8771f681, 11);
    00228    MD5STEP(F3, c, d, a, b, in[11] + 0x6d9d6122, 16);
    00229    MD5STEP(F3, b, c, d, a, in[14] + 0xfde5380c, 23);
    00230    MD5STEP(F3, a, b, c, d, in[1] + 0xa4beea44, 4);
    00231    MD5STEP(F3, d, a, b, c, in[4] + 0x4bdecfa9, 11);
    00232    MD5STEP(F3, c, d, a, b, in[7] + 0xf6bb4b60, 16);
    00233    MD5STEP(F3, b, c, d, a, in[10] + 0xbebfbc70, 23);
    00234    MD5STEP(F3, a, b, c, d, in[13] + 0x289b7ec6, 4);
    00235    MD5STEP(F3, d, a, b, c, in[0] + 0xeaa127fa, 11);
    00236    MD5STEP(F3, c, d, a, b, in[3] + 0xd4ef3085, 16);
    00237    MD5STEP(F3, b, c, d, a, in[6] + 0x04881d05, 23);
    00238    MD5STEP(F3, a, b, c, d, in[9] + 0xd9d4d039, 4);
    00239    MD5STEP(F3, d, a, b, c, in[12] + 0xe6db99e5, 11);
    00240    MD5STEP(F3, c, d, a, b, in[15] + 0x1fa27cf8, 16);
    00241    MD5STEP(F3, b, c, d, a, in[2] + 0xc4ac5665, 23);
    00242
    00243    MD5STEP(F4, a, b, c, d, in[0] + 0xf4292244, 6);
    00244    MD5STEP(F4, d, a, b, c, in[7] + 0x432aff97, 10);
    00245    MD5STEP(F4, c, d, a, b, in[14] + 0xab9423a7, 15);
    00246    MD5STEP(F4, b, c, d, a, in[5] + 0xfc93a039, 21);
    00247    MD5STEP(F4, a, b, c, d, in[12] + 0x655b59c3, 6);
    00248    MD5STEP(F4, d, a, b, c, in[3] + 0x8f0ccc92, 10);
    00249    MD5STEP(F4, c, d, a, b, in[10] + 0xffeff47d, 15);
    00250    MD5STEP(F4, b, c, d, a, in[1] + 0x85845dd1, 21);
    00251    MD5STEP(F4, a, b, c, d, in[8] + 0x6fa87e4f, 6);
    00252    MD5STEP(F4, d, a, b, c, in[15] + 0xfe2ce6e0, 10);
    00253    MD5STEP(F4, c, d, a, b, in[6] + 0xa3014314, 15);
    00254    MD5STEP(F4, b, c, d, a, in[13] + 0x4e0811a1, 21);
    00255    MD5STEP(F4, a, b, c, d, in[4] + 0xf7537e82, 6);
    00256    MD5STEP(F4, d, a, b, c, in[11] + 0xbd3af235, 10);
    00257    MD5STEP(F4, c, d, a, b, in[2] + 0x2ad7d2bb, 15);
    00258    MD5STEP(F4, b, c, d, a, in[9] + 0xeb86d391, 21);
    00259
    00260    buf[0] += a;
    00261    buf[1] += b;
    00262    buf[2] += c;
    00263    buf[3] += d;
    00264 }

void MD5Update | ( | struct MD5Context * | context,
|  | unsigned char const * | buf,
|  | unsigned | len |
| ) |  |  |

Definition at line 75 of file md5.c.

References MD5Context::bits, MD5Context::buf, byteReverse(), MD5Context::in, MD5Transform(), and t.

Referenced by ast_md5_hash(), authenticate(), authenticate_verify(), decrypt_frame(), festival_exec(), prov_ver_calc(), register_verify(), try_firmware(), try_load_key(), and verify_key().

    00076 {
    00077    uint32_t t;
    00078
    00079    /* Update bitcount */
    00080
    00081    t = ctx->bits[0];
    00082    if ((ctx->bits[0] = t + ((uint32_t) len << 3)) < t)
    00083       ctx->bits[1]++;      /* Carry from low to high */
    00084    ctx->bits[1] += len >> 29;
    00085
    00086    t = (t >> 3) & 0x3f; /* Bytes already in shsInfo->data */
    00087
    00088    /* Handle any leading odd-sized chunks */
    00089
    00090    if (t) {
    00091       unsigned char *p = (unsigned char *) ctx->in + t;
    00092
    00093       t = 64 - t;
    00094       if (len < t) {
    00095          memcpy(p, buf, len);
    00096          return;
    00097       }
    00098       memcpy(p, buf, t);
    00099       byteReverse(ctx->in, 16);
    00100       MD5Transform(ctx->buf, (uint32_t *) ctx->in);
    00101       buf += t;
    00102       len -= t;
    00103    }
    00104    /* Process data in 64-byte chunks */
    00105
    00106    while (len >= 64) {
    00107       memcpy(ctx->in, buf, 64);
    00108       byteReverse(ctx->in, 16);
    00109       MD5Transform(ctx->buf, (uint32_t *) ctx->in);
    00110       buf += 64;
    00111       len -= 64;
    00112    }
    00113
    00114    /* Handle any remaining bytes of data. */
    00115
    00116    memcpy(ctx->in, buf, len);
    00117 }